    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * --------------
    028     * RangeType.java
    029     * --------------
    030     * (C) Copyright 2005, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * $Id: RangeType.java,v 1.2.2.1 2005/10/25 21:29:13 mungady Exp $
    036     *
    037     * Changes:
    038     * --------
    039     * 24-Feb-2005 : Version 1 (DG);
    040     *
    041     */
    042
    043    package org.jfree.data;
    044
    045    import java.io.ObjectStreamException;
    046    import java.io.Serializable;
    047
    048    /**
    049     * Used to indicate the type of range to display on an axis (full, positive or
    050     * negative).
    051     */
    052    public final class RangeType implements Serializable {
    053
    054        /** For serialization. */
    055        private static final long serialVersionUID = -9073319010650549239L;
    056
    057        /** Full range (positive and negative). */
    058        public static final RangeType FULL = new RangeType("RangeType.FULL");
    059
    060        /** Positive range. */
    061        public static final RangeType POSITIVE
    062            = new RangeType("RangeType.POSITIVE");
    063
    064        /** Negative range. */
    065        public static final RangeType NEGATIVE
    066            = new RangeType("RangeType.NEGATIVE");
    067
    068        /** The name. */
    069        private String name;
    070
    071        /**
    072         * Private constructor.
    073         *
    074         * @param name  the name.
    075         */
    076        private RangeType(String name) {
    077            this.name = name;
    078        }
    079
    080        /**
    081         * Returns a string representing the object.
    082         *
    083         * @return The string.
    084         */
    085        public String toString() {
    086            return this.name;
    087        }
    088
    089        /**
    090         * Returns <code>true</code> if this object is equal to the specified
    091         * object, and <code>false</code> otherwise.
    092         *
    093         * @param obj  the other object.
    094         *
    095         * @return A boolean.
    096         */
    097        public boolean equals(Object obj) {
    098
    099            if (this == obj) {
    100                return true;
    101            }
    102            if (!(obj instanceof RangeType)) {
    103                return false;
    104            }
    105            RangeType that = (RangeType) obj;
    106            if (!this.name.equals(that.toString())) {
    107                return false;
    108            }
    109            return true;
    110        }
    111
    112        /**
    113         * Returns a hash code value for the object.
    114         *
    115         * @return The hashcode
    116         */
    117        public int hashCode() {
    118            return this.name.hashCode();
    119        }
    120
    121        /**
    122         * Ensures that serialization returns the unique instances.
    123         *
    124         * @return The object.
    125         *
    126         * @throws ObjectStreamException if there is a problem.
    127         */
    128        private Object readResolve() throws ObjectStreamException {
    129            if (this.equals(RangeType.FULL)) {
    130                return RangeType.FULL;
    131            }
    132            else if (this.equals(RangeType.POSITIVE)) {
    133                return RangeType.POSITIVE;
    134            }
    135            else if (this.equals(RangeType.NEGATIVE)) {
    136                return RangeType.NEGATIVE;
    137            }
    138            return null;
    139        }
    140
    141    }